## ros-kinetic-mavros 1.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(mavros)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  angles
  diagnostic_msgs
  diagnostic_updater
  eigen_conversions
  geographic_msgs
  geometry_msgs
  libmavconn
  mavros_msgs
  nav_msgs
  pluginlib
  rosconsole_bridge
  roscpp
  sensor_msgs
  std_msgs
  std_srvs
  tf2_eigen
  tf2_ros
  trajectory_msgs
)

## System dependencies are found with CMake's conventions
find_package(Boost REQUIRED COMPONENTS system)

## Find Eigen
find_package(Eigen3)
if(NOT EIGEN3_FOUND)
  # Fallback to cmake_modules
  find_package(cmake_modules REQUIRED)
  find_package(Eigen REQUIRED)
  set(EIGEN3_INCLUDE_DIRS ${EIGEN_INCLUDE_DIRS})
  set(EIGEN3_LIBRARIES ${EIGEN_LIBRARIES})
endif()

## Find GeographicLib
find_package(GeographicLib REQUIRED)

## Check if the datasets are installed
include(CheckGeographicLibDatasets)

include(EnableCXX11)
include(MavrosMavlink)

# detect if sensor_msgs has BatteryState.msg
# http://answers.ros.org/question/223769/how-to-check-that-message-exists-with-catkin-for-conditional-compilation-sensor_msgsbatterystate/
list(FIND sensor_msgs_MESSAGE_FILES "msg/BatteryState.msg" BATTERY_STATE_MSG_IDX)
if(${BATTERY_STATE_MSG_IDX} GREATER -1)
  add_definitions(
    -DHAVE_SENSOR_MSGS_BATTERYSTATE_MSG
  )
endif()

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
catkin_python_setup()


###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES mavros
  CATKIN_DEPENDS diagnostic_msgs diagnostic_updater eigen_conversions geographic_msgs geometry_msgs libmavconn mavros_msgs message_runtime nav_msgs pluginlib roscpp sensor_msgs std_msgs tf2_ros trajectory_msgs
  DEPENDS Boost EIGEN3 GeographicLib
)

###########
## Build ##
###########

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
  ${mavlink_INCLUDE_DIRS}
  ${EIGEN3_INCLUDE_DIRS}
  ${GeographicLib_INCLUDE_DIRS}
)

add_library(mavros
  src/lib/enum_sensor_orientation.cpp
  src/lib/enum_to_string.cpp
  src/lib/ftf_frame_conversions.cpp
  src/lib/ftf_quaternion_utils.cpp
  src/lib/mavlink_diag.cpp
  src/lib/mavros.cpp
  src/lib/rosconsole_bridge.cpp
  src/lib/uas_data.cpp
  src/lib/uas_stringify.cpp
  src/lib/uas_timesync.cpp
)
add_dependencies(mavros
  ${catkin_EXPORTED_TARGETS}
)
target_link_libraries(mavros
  atomic
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
  ${GeographicLib_LIBRARIES}
)

add_library(mavros_plugins
  src/plugins/3dr_radio.cpp
  src/plugins/actuator_control.cpp
  src/plugins/altitude.cpp
  src/plugins/command.cpp
  src/plugins/dummy.cpp
  src/plugins/ftp.cpp
  src/plugins/global_position.cpp
  src/plugins/hil.cpp
  src/plugins/home_position.cpp
  src/plugins/imu.cpp
  src/plugins/local_position.cpp
  src/plugins/manual_control.cpp
  src/plugins/param.cpp
  src/plugins/rc_io.cpp
  src/plugins/safety_area.cpp
  src/plugins/setpoint_accel.cpp
  src/plugins/setpoint_attitude.cpp
  src/plugins/setpoint_position.cpp
  src/plugins/setpoint_raw.cpp
  src/plugins/setpoint_velocity.cpp
  src/plugins/setpoint_trajectory.cpp
  src/plugins/sys_status.cpp
  src/plugins/sys_time.cpp
  src/plugins/vfr_hud.cpp
  src/plugins/waypoint.cpp
  src/plugins/wind_estimation.cpp
)
add_dependencies(mavros_plugins
  mavros
)
target_link_libraries(mavros_plugins
  mavros
  ${catkin_LIBRARIES}
)

## Declare a cpp executable
add_executable(mavros_node
  src/mavros_node.cpp
)
add_dependencies(mavros_node
  mavros
)
target_link_libraries(mavros_node
  mavros
  ${catkin_LIBRARIES}
)

add_executable(gcs_bridge
  src/gcs_bridge.cpp
)
target_link_libraries(gcs_bridge
  mavros
  ${catkin_LIBRARIES}
)

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
file(GLOB SCRIPTS ${PROJECT_SOURCE_DIR}/scripts/*)
catkin_install_python(PROGRAMS
  ${SCRIPTS}
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark executables and/or libraries for installation
install(TARGETS gcs_bridge mavros mavros_node mavros_plugins
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

## Mark other files for installation (e.g. launch and bag files, etc.)
install(FILES
  mavros_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
)

#############
## Testing ##
#############

if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(libmavros-frame-conversions-test test/test_frame_conversions.cpp)
  target_link_libraries(libmavros-frame-conversions-test mavros)

  catkin_add_gtest(libmavros-sensor-orientation-test test/test_sensor_orientation.cpp)
  target_link_libraries(libmavros-sensor-orientation-test mavros)

  catkin_add_gtest(libmavros-quaternion-utils-test test/test_quaternion_utils.cpp)
  target_link_libraries(libmavros-quaternion-utils-test mavros)
## Add folders to be run by python nosetests
# catkin_add_nosetests(test)

endif()

# vim: ts=2 sw=2 et:

=== debian/changelog ===
ros-kinetic-mavros (1.6.0-1xenial) xenial; urgency=high

  * fix inconsistency in direction of yaw when using set_position in BODY frames and fix problems with yaw in setponit_raw
  * Contributors: zhouzhiwen2000

 -- Vladimir Ermakov <vooon341@gmail.com>  Mon, 15 Feb 2021 00:00:00 -0000

ros-kinetic-mavros (1.5.2-1xenial) xenial; urgency=high

  * readme: add source install note for Noetic release
  * Contributors: Vladimir Ermakov

 -- Vladimir Ermakov <vooon341@gmail.com>  Tue, 02 Feb 2021 00:00:00 -0000

ros-kinetic-mavros (1.5.1-1xenial) xenial; urgency=high

  * Fix tests for renaming of ECEF cases
    Introduced in 6234af29
  * Initialise message structures
    Uninitialised Mavlink 2 extension fields were sent if the fields were
    not later set. Initialising the fields to zero is the default value for
    extension fields and appears to the receiver as though sender is unaware
    of Mavlink 2.
    Instances were found with regex below, more may exist:
    mavlink::[^:]+::msg::[^:={]+ ?[^:={]*;
  * Contributors: Rob Clarke

 -- Vladimir Ermakov <vooon341@gmail.com>  Mon, 04 Jan 2021 00:00:00 -0000

ros-kinetic-mavros (1.5.0-1xenial) xenial; urgency=high

  * mavros/sys_status: Fill flight_custom_version field
  * mavros: Add override specifiers
  * mavros: Move ECEF tf enums to separate enum class
    This avoids a bunch of unhandled switch cases, and should
    improve type safety a bit.
  * Contributors: Morten Fyhn Amundsen

 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 11 Nov 2020 00:00:00 -0000

ros-kinetic-mavros (1.4.0-1xenial) xenial; urgency=high

  * mavros: use mavlink::minimal:: after incompatible changes in mavlink package
    Incompatible change: https://github.com/mavlink/mavlink/pull/1463
    Fix: #1483 <https://github.com/mavlink/mavros/issues/1483>, https://github.com/mavlink/mavlink/issues/1474
  * fixes based on vooon's review
  * fix issue what we couldn't set real parameters to 0.0 in mavros
  * Add error message
  * Fixed compilation error: publish std_msgs::String, not std::string for gcs_ip
  * Dispatch GCS IP address
  * Contributors: Artem Batalov, Marcelino, Morten Fyhn Amundsen, Vladimir Ermakov, Øystein Skotheim

 -- Vladimir Ermakov <vooon341@gmail.com>  Fri, 11 Sep 2020 00:00:00 -0000

ros-kinetic-mavros (1.3.0-1xenial) xenial; urgency=high

  * fake_gps.cpp: implement speed accuracy
  * fake_gps.cpp: Add mocap_withcovariance configuration parameter
  * fake_gps.cpp: add initial support for GPS_INPUT MAVLink message
  * apm.launch: Avoid warning:
    Warning: You are using <arg> inside an <include> tag with the default=XY attribute - which is superfluous.
    Use value=XY instead for less confusion.
    Attribute name: respawn_mavros
  * Added support for MavProxy parameter file format
  * Ignore read-only parameters and statistics parameters in push operations
  * fix indentation
  * transform based on coordinate_frame
  * wind plugin: fix ArduPilot wind transformation
  * Contributors: Ben Wolsieffer, Dr.-Ing. Amilcar do Carmo Lucas, Yuan, Yuan Xu

 -- Vladimir Ermakov <vooon341@gmail.com>  Sat, 08 Aug 2020 00:00:00 -0000

ros-kinetic-mavros (1.2.0-1xenial) xenial; urgency=high

  * has_capability only works for enums
  * Uncrustify
  * Reworked Waypoint plugin to use capabilities_cb
    Additionally added helper functions has_capability and has_capabilities
    so that people can use either ints or enums to check if the UAS has a
    capability. This might make accepting capabilities as a parameter moot
    though.
  * Added alias for capabilities enum to UAS
  * Added alias for capabilities enum to UAS
  * Added a capabilities change cb queue
    Plugins can now write functions that they add to the
    capabilities_cb_vec. These functions will be called only when there is a
    change to the capabilities themselves not whenever the known status of
    the fcu_capabilities change.
    These functions should have a parameter of type
    mavlink::common::MAV_PROTOCOL_CAPABILITY which is essentially just a
    uint64_t however being more opinionated is helpful when looking for what
    the canonical enum names are in the mavlink project header files.
  * Uncrustify
  * Fixed Removed Uncrustify Option
    I'm not sure why this didn't break when I ran uncrustify previously but
    it seems that the align_number_left option was removed a while ago with
    this merge request but I may be mistaken
    https://github.com/uncrustify/uncrustify/pull/1393
    I replaced it which align_number_right=true since it seems to be the
    inverse of align_number_left=true.
  * Removed deprecated MAV_FRAME values
  * Removed use of variant in favor of templates
    Since ROS messages are now the storage type in the node, providing to
    and from conversion functions is sufficient and can be better expressed
    with function templates.
  * Encode factor returns double
  * Changed encoding factor cog code
  * Uncrustify changes
  * Added new parameter to config.yamls
  * Updated waypoint plugin to support MISSION_ITEM_INT
    These changes add a new parameter use_mission_item_int, which allows
    users to prefer the old behavior. These changes also verify that the
    flight controller supports _INT messages since APM only sends
    REQUEST_ITEM messages even though it accepts _INT items back.
    This commit is functional and tested with the APM stack only.
    PX4 sitl jmavsim threw:
    WP: upload failed: Command is not supported.
    FCU: IGN MISSION_ITEM: Busy
  * Removed x_lat, y_long, z_alt from WP
    These values seemed to be used due to the fact that double had
    a greater resolution than float and doubles are used in the
    ros msg. However they were only ever used for printing. Since
    the int version of these messages has a greater resolution I
    figure it is more useful to print the true value in the mavlink
    message rather than the ros message value
  * Replaced MISSION_ITEM
  * add yaw to CMD_DO_SET_HOME


=== debian/control ===
Source: ros-kinetic-mavros
Section: misc
Priority: optional
Maintainer: Vladimir Ermakov <vooon341@gmail.com>
Build-Depends: debhelper (>= 9.0.0), geographiclib-tools, libboost-all-dev, libeigen3-dev, libgeographic-dev, libgtest-dev, ros-kinetic-angles, ros-kinetic-catkin, ros-kinetic-cmake-modules, ros-kinetic-diagnostic-msgs, ros-kinetic-diagnostic-updater, ros-kinetic-eigen-conversions, ros-kinetic-geographic-msgs, ros-kinetic-geometry-msgs, ros-kinetic-libmavconn, ros-kinetic-mavlink, ros-kinetic-mavros-msgs, ros-kinetic-nav-msgs, ros-kinetic-pluginlib, ros-kinetic-rosconsole-bridge, ros-kinetic-roscpp, ros-kinetic-rosunit, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-tf2-eigen, ros-kinetic-tf2-ros, ros-kinetic-trajectory-msgs
Homepage: http://wiki.ros.org/mavros
Standards-Version: 3.9.2

Package: ros-kinetic-mavros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, geographiclib-tools, libboost-all-dev, libeigen3-dev, libgeographic-dev, ros-kinetic-diagnostic-msgs, ros-kinetic-diagnostic-updater, ros-kinetic-eigen-conversions, ros-kinetic-geographic-msgs, ros-kinetic-geometry-msgs, ros-kinetic-libmavconn, ros-kinetic-mavlink, ros-kinetic-mavros-msgs, ros-kinetic-message-runtime, ros-kinetic-nav-msgs, ros-kinetic-pluginlib, ros-kinetic-rosconsole-bridge, ros-kinetic-roscpp, ros-kinetic-rospy, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-tf2-eigen, ros-kinetic-tf2-ros, ros-kinetic-trajectory-msgs
Description: MAVROS -- MAVLink extendable communication node for ROS with proxy for Ground Control Station.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-mavros//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
